import { Libp2p } from "libp2p";
import type { Components } from "libp2p/components";
import { DirectSub } from "@dao-xyz/libp2p-direct-sub";
import { DirectBlock } from "@dao-xyz/libp2p-direct-block";
import type { RecursivePartial } from "@libp2p/interfaces";
import type { Transport } from "@libp2p/interface-transport";
import { AddressManagerInit } from "libp2p/address-manager";
import { PeerId } from "@libp2p/interface-peer-id";
import { ConnectionManagerInit } from "libp2p/connection-manager";
import { CircuitRelayService } from "libp2p/dist/src/circuit-relay/index.js";
export type Libp2pExtendServices = {
    directsub: DirectSub;
    directblock: DirectBlock;
};
export type Libp2pExtended = Libp2p<{
    relay: CircuitRelayService;
    identify: any;
} & Libp2pExtendServices>;
export type ExtendedServicesOptions = {
    directsub: (components: any) => DirectSub;
    directblock: (components: any) => DirectBlock;
};
export type CreateOptions = {
    transports?: RecursivePartial<(components: Components) => Transport>[];
    addresses?: RecursivePartial<AddressManagerInit>;
    peerId?: RecursivePartial<PeerId>;
    connectionManager?: RecursivePartial<ConnectionManagerInit>;
    directory?: string;
    services?: ExtendedServicesOptions;
};
export type CreateLibp2pExtendedOptions = {
    libp2p?: CreateOptions;
};
export declare const createLibp2pExtended: (opts?: CreateOptions) => Promise<Libp2pExtended>;
