import { createLibp2p } from "libp2p";
import { DirectSub } from "@dao-xyz/libp2p-direct-sub";
import { DirectBlock } from "@dao-xyz/libp2p-direct-block";
import { noise } from "@dao-xyz/libp2p-noise";
import { mplex } from "@libp2p/mplex";
import { transports, relay } from "./transports.js";
import { identifyService } from "libp2p/identify";
export const createLibp2pExtended = (opts = {}) => createLibp2p({
    peerId: opts?.peerId,
    connectionManager: opts?.connectionManager || {
        minConnections: 0,
    },
    addresses: opts?.addresses || {
        listen: ["/ip4/127.0.0.1/tcp/0", "/ip4/127.0.0.1/tcp/0/ws"],
    },
    transports: opts?.transports || transports(),
    connectionEncryption: [noise()],
    streamMuxers: [mplex()],
    services: {
        relay: relay(),
        identify: identifyService(),
        directsub: opts.services?.directsub ||
            ((c) => new DirectSub(c, {
                canRelayMessage: true,
                signaturePolicy: "StrictNoSign",
                connectionManager: {
                    autoDial: true,
                },
            })),
        directblock: opts.services?.directblock || ((c) => new DirectBlock(c)),
    },
});
//# sourceMappingURL=index.js.map